/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _ATTACHMENT_H_
#define _ATTACHMENT_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
        class Message;
}

#include "embeddedfiledataobject.h"
#include <nepomuk/nepomuk_export.h>

namespace Nepomuk {

/**
 * A file attached to another data object. Many data formats allow 
 * for attachments: emails, vcards, ical events, id3 and exif... 
 */
    class NEPOMUK_EXPORT Attachment : public EmbeddedFileDataObject
    {
    public:
        /**
         * Create a new empty and invalid Attachment instance
         */
        Attachment();
        /**
         * Default copy constructor
         */
        Attachment( const Attachment& );
        Attachment( const Resource& );
        /**
         * Create a new Attachment instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        Attachment( const QString& uriOrIdentifier );
        /**
         * Create a new Attachment instance representing the resource
         * referenced by \a uri.
         */
        Attachment( const QUrl& uri );
        ~Attachment();

        Attachment& operator=( const Attachment& );

            /**
             * Get all resources that have this resource set as property 'Attachment'. 
             * Links a message with files that were sent as attachments. \sa 
             * ResourceManager::allResourcesWithProperty 
             */
            QList<Message> attachmentOf() const;

            /**
             * Retrieve a list of all available Attachment resources. This 
             * list consists of all resource of type Attachment that are stored 
             * in the local Nepomuk meta data storage and any changes made locally. 
             * Be aware that in some cases this list can get very big. Then it 
             * might be better to use libKNep directly. 
             */
            static QList<Attachment> allAttachments();


        /**
         * \return The URI of the resource type that is used in Attachment instances.
         */
        static QString resourceTypeUri();

    protected:
       Attachment( const QString& uri, const QUrl& type );
       Attachment( const QUrl& uri, const QUrl& type );
   };
}

#endif
