/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _CARPHONENUMBER_H_
#define _CARPHONENUMBER_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
}

#include "voicephonenumber.h"
#include <nepomuk/nepomuk_export.h>

namespace Nepomuk {

/**
 * A car phone number. Inspired by the (TYPE=car) parameter of 
 * the TEL property as defined in RFC 2426 sec 3.3.1. 
 */
    class NEPOMUK_EXPORT CarPhoneNumber : public VoicePhoneNumber
    {
    public:
        /**
         * Create a new empty and invalid CarPhoneNumber instance
         */
        CarPhoneNumber();
        /**
         * Default copy constructor
         */
        CarPhoneNumber( const CarPhoneNumber& );
        CarPhoneNumber( const Resource& );
        /**
         * Create a new CarPhoneNumber instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        CarPhoneNumber( const QString& uriOrIdentifier );
        /**
         * Create a new CarPhoneNumber instance representing the resource
         * referenced by \a uri.
         */
        CarPhoneNumber( const QUrl& uri );
        ~CarPhoneNumber();

        CarPhoneNumber& operator=( const CarPhoneNumber& );

            /**
             * Retrieve a list of all available CarPhoneNumber resources. 
             * This list consists of all resource of type CarPhoneNumber that 
             * are stored in the local Nepomuk meta data storage and any changes 
             * made locally. Be aware that in some cases this list can get very 
             * big. Then it might be better to use libKNep directly. 
             */
            static QList<CarPhoneNumber> allCarPhoneNumbers();


        /**
         * \return The URI of the resource type that is used in CarPhoneNumber instances.
         */
        static QString resourceTypeUri();

    protected:
       CarPhoneNumber( const QString& uri, const QUrl& type );
       CarPhoneNumber( const QUrl& uri, const QUrl& type );
   };
}

#endif
