/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _COMPRESSIONTYPE_H_
#define _COMPRESSIONTYPE_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
        class Media;
}

#include <nepomuk/resource.h>
#include <nepomuk/nepomuk_export.h>

namespace Nepomuk {

/**
 * Type of compression. Instances of this class represent the 
 * limited set of values allowed for the nfo:compressionType 
 * property. 
 */
    class NEPOMUK_EXPORT CompressionType : public Resource
    {
    public:
        /**
         * Create a new empty and invalid CompressionType instance
         */
        CompressionType();
        /**
         * Default copy constructor
         */
        CompressionType( const CompressionType& );
        CompressionType( const Resource& );
        /**
         * Create a new CompressionType instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        CompressionType( const QString& uriOrIdentifier );
        /**
         * Create a new CompressionType instance representing the resource
         * referenced by \a uri.
         */
        CompressionType( const QUrl& uri );
        ~CompressionType();

        CompressionType& operator=( const CompressionType& );

            /**
             * Get all resources that have this resource set as property 'compressionType'. 
             * The type of the compression. Values include, 'lossy' and 'lossless'. 
             * \sa ResourceManager::allResourcesWithProperty 
             */
            QList<Media> compressionTypeOf() const;

            /**
             * Retrieve a list of all available CompressionType resources. 
             * This list consists of all resource of type CompressionType 
             * that are stored in the local Nepomuk meta data storage and any 
             * changes made locally. Be aware that in some cases this list can 
             * get very big. Then it might be better to use libKNep directly. 
             */
            static QList<CompressionType> allCompressionTypes();


        /**
         * \return The URI of the resource type that is used in CompressionType instances.
         */
        static QString resourceTypeUri();

    protected:
       CompressionType( const QString& uri, const QUrl& type );
       CompressionType( const QUrl& uri, const QUrl& type );
   };
}

#endif
