/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _EMBEDDEDFILEDATAOBJECT_H_
#define _EMBEDDEDFILEDATAOBJECT_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
}

#include "filedataobject.h"
#include <nepomuk/nepomuk_export.h>

namespace Nepomuk {

/**
 * A file embedded in another data object. There are many ways in 
 * which a file may be embedded in another one. Use this class directly 
 * only in cases if none of the subclasses gives a better description 
 * of your case. 
 */
    class NEPOMUK_EXPORT EmbeddedFileDataObject : public FileDataObject
    {
    public:
        /**
         * Create a new empty and invalid EmbeddedFileDataObject instance
         */
        EmbeddedFileDataObject();
        /**
         * Default copy constructor
         */
        EmbeddedFileDataObject( const EmbeddedFileDataObject& );
        EmbeddedFileDataObject( const Resource& );
        /**
         * Create a new EmbeddedFileDataObject instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        EmbeddedFileDataObject( const QString& uriOrIdentifier );
        /**
         * Create a new EmbeddedFileDataObject instance representing the resource
         * referenced by \a uri.
         */
        EmbeddedFileDataObject( const QUrl& uri );
        ~EmbeddedFileDataObject();

        EmbeddedFileDataObject& operator=( const EmbeddedFileDataObject& );

            /**
             * Get property 'encoding'. The encoding used for the Embedded 
             * File. Examples might include BASE64 or UUEncode 
             */
            QStringList encodings() const;

            /**
             * Set property 'encoding'. The encoding used for the Embedded 
             * File. Examples might include BASE64 or UUEncode 
             */
            void setEncodings( const QStringList& value );

            /**
             * Add a value to property 'encoding'. The encoding used for the 
             * Embedded File. Examples might include BASE64 or UUEncode 
             */
            void addEncoding( const QString& value );

            /**
             * \return The URI of the property 'encoding'. 
             */
            static QUrl encodingUri();

            /**
             * Retrieve a list of all available EmbeddedFileDataObject resources. 
             * This list consists of all resource of type EmbeddedFileDataObject 
             * that are stored in the local Nepomuk meta data storage and any 
             * changes made locally. Be aware that in some cases this list can 
             * get very big. Then it might be better to use libKNep directly. 
             */
            static QList<EmbeddedFileDataObject> allEmbeddedFileDataObjects();


        /**
         * \return The URI of the resource type that is used in EmbeddedFileDataObject instances.
         */
        static QString resourceTypeUri();

    protected:
       EmbeddedFileDataObject( const QString& uri, const QUrl& type );
       EmbeddedFileDataObject( const QUrl& uri, const QUrl& type );
   };
}

#endif
