/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _MODEMNUMBER_H_
#define _MODEMNUMBER_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
}

#include "phonenumber.h"
#include <nepomuk/nepomuk_export.h>

namespace Nepomuk {

/**
 * A modem phone number. Inspired by the (TYPE=modem) parameter 
 * of the TEL property as defined in RFC 2426 sec 3.3.1. 
 */
    class NEPOMUK_EXPORT ModemNumber : public PhoneNumber
    {
    public:
        /**
         * Create a new empty and invalid ModemNumber instance
         */
        ModemNumber();
        /**
         * Default copy constructor
         */
        ModemNumber( const ModemNumber& );
        ModemNumber( const Resource& );
        /**
         * Create a new ModemNumber instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        ModemNumber( const QString& uriOrIdentifier );
        /**
         * Create a new ModemNumber instance representing the resource
         * referenced by \a uri.
         */
        ModemNumber( const QUrl& uri );
        ~ModemNumber();

        ModemNumber& operator=( const ModemNumber& );

            /**
             * Retrieve a list of all available ModemNumber resources. This 
             * list consists of all resource of type ModemNumber that are stored 
             * in the local Nepomuk meta data storage and any changes made locally. 
             * Be aware that in some cases this list can get very big. Then it 
             * might be better to use libKNep directly. 
             */
            static QList<ModemNumber> allModemNumbers();


        /**
         * \return The URI of the resource type that is used in ModemNumber instances.
         */
        static QString resourceTypeUri();

    protected:
       ModemNumber( const QString& uri, const QUrl& type );
       ModemNumber( const QUrl& uri, const QUrl& type );
   };
}

#endif
