/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _PCSNUMBER_H_
#define _PCSNUMBER_H_

class QDateTime;
class QDate;
class QTime;

namespace Nepomuk {
}

#include "voicephonenumber.h"
#include <nepomuk/nepomuk_export.h>

namespace Nepomuk {

/**
 * Personal Communication Services Number. A class inspired 
 * by the TYPE=pcs parameter of the TEL property defined in RFC 
 * 2426 sec. 3.3.1 
 */
    class NEPOMUK_EXPORT PcsNumber : public VoicePhoneNumber
    {
    public:
        /**
         * Create a new empty and invalid PcsNumber instance
         */
        PcsNumber();
        /**
         * Default copy constructor
         */
        PcsNumber( const PcsNumber& );
        PcsNumber( const Resource& );
        /**
         * Create a new PcsNumber instance representing the resource
         * referenced by \a uriOrIdentifier.
         */
        PcsNumber( const QString& uriOrIdentifier );
        /**
         * Create a new PcsNumber instance representing the resource
         * referenced by \a uri.
         */
        PcsNumber( const QUrl& uri );
        ~PcsNumber();

        PcsNumber& operator=( const PcsNumber& );

            /**
             * Retrieve a list of all available PcsNumber resources. This 
             * list consists of all resource of type PcsNumber that are stored 
             * in the local Nepomuk meta data storage and any changes made locally. 
             * Be aware that in some cases this list can get very big. Then it 
             * might be better to use libKNep directly. 
             */
            static QList<PcsNumber> allPcsNumbers();


        /**
         * \return The URI of the resource type that is used in PcsNumber instances.
         */
        static QString resourceTypeUri();

    protected:
       PcsNumber( const QString& uri, const QUrl& type );
       PcsNumber( const QUrl& uri, const QUrl& type );
   };
}

#endif
