/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <nepomuk/tools.h>
#include <nepomuk/variant.h>
#include <nepomuk/resourcemanager.h>
#include "personcontact.h"

#include "affiliation.h"
#include "gender.h"
#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>


Nepomuk::PersonContact::PersonContact()
  : Contact( QUrl(), QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PersonContact") )
{
}


Nepomuk::PersonContact::PersonContact( const PersonContact& res )
  : Contact( res )
{
}


Nepomuk::PersonContact::PersonContact( const Nepomuk::Resource& res )
  : Contact( res )
{
}


Nepomuk::PersonContact::PersonContact( const QString& uri )
  : Contact( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PersonContact") )
{
}

Nepomuk::PersonContact::PersonContact( const QUrl& uri )
  : Contact( uri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PersonContact") )
{
}

Nepomuk::PersonContact::PersonContact( const QString& uri, const QUrl& type )
  : Contact( uri, type )
{
}

Nepomuk::PersonContact::PersonContact( const QUrl& uri, const QUrl& type )
  : Contact( uri, type )
{
}

Nepomuk::PersonContact::~PersonContact()
{
}


Nepomuk::PersonContact& Nepomuk::PersonContact::operator=( const PersonContact& res )
{
    Resource::operator=( res );
    return *this;
}


QString Nepomuk::PersonContact::resourceTypeUri()
{
    return "http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PersonContact";
}

QStringList Nepomuk::PersonContact::hobbys() const
{
    return ( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby") ).toStringList());
}

void Nepomuk::PersonContact::setHobbys( const QStringList& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby"), Variant( value ) );
}

void Nepomuk::PersonContact::addHobby( const QString& value )
{
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby") );
    v.append( value );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby"), v );
}

QUrl Nepomuk::PersonContact::hobbyUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hobby");
}

Nepomuk::Gender Nepomuk::PersonContact::gender() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    return Gender( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#gender") ).toResource().uri() );
}

void Nepomuk::PersonContact::setGender( const Nepomuk::Gender& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#gender"), Variant( value ) );
}

QUrl Nepomuk::PersonContact::genderUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#gender");
}

QStringList Nepomuk::PersonContact::nameGivens() const
{
    return ( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven") ).toStringList());
}

void Nepomuk::PersonContact::setNameGivens( const QStringList& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven"), Variant( value ) );
}

void Nepomuk::PersonContact::addNameGiven( const QString& value )
{
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven") );
    v.append( value );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven"), v );
}

QUrl Nepomuk::PersonContact::nameGivenUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameGiven");
}

QList<Nepomuk::Affiliation> Nepomuk::PersonContact::affiliations() const
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    return convertResourceList<Affiliation>( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation") ).toResourceList() );
}

void Nepomuk::PersonContact::setAffiliations( const QList<Nepomuk::Affiliation>& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    QList<Resource> l;
    for( QList<Affiliation>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
        l.append( Resource( (*it) ) );
    }
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation"), Variant( l ) );
}

void Nepomuk::PersonContact::addAffiliation( const Nepomuk::Affiliation& value )
{
    // We always store all Resource types as plain Resource objects.
    // It does not introduce any overhead (due to the implicit sharing of
    // the data and has the advantage that we can mix setProperty calls
    // with the special Resource subclass methods.
    // More importantly Resource loads the data as Resource objects anyway.
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation") );
    v.append( Resource( value ) );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation"), v );
}

QUrl Nepomuk::PersonContact::affiliationUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#hasAffiliation");
}

QStringList Nepomuk::PersonContact::nameFamilys() const
{
    return ( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily") ).toStringList());
}

void Nepomuk::PersonContact::setNameFamilys( const QStringList& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily"), Variant( value ) );
}

void Nepomuk::PersonContact::addNameFamily( const QString& value )
{
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily") );
    v.append( value );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily"), v );
}

QUrl Nepomuk::PersonContact::nameFamilyUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameFamily");
}

QStringList Nepomuk::PersonContact::nameHonorificPrefixs() const
{
    return ( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix") ).toStringList());
}

void Nepomuk::PersonContact::setNameHonorificPrefixs( const QStringList& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix"), Variant( value ) );
}

void Nepomuk::PersonContact::addNameHonorificPrefix( const QString& value )
{
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix") );
    v.append( value );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix"), v );
}

QUrl Nepomuk::PersonContact::nameHonorificPrefixUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificPrefix");
}

QStringList Nepomuk::PersonContact::nameAdditionals() const
{
    return ( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional") ).toStringList());
}

void Nepomuk::PersonContact::setNameAdditionals( const QStringList& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional"), Variant( value ) );
}

void Nepomuk::PersonContact::addNameAdditional( const QString& value )
{
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional") );
    v.append( value );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional"), v );
}

QUrl Nepomuk::PersonContact::nameAdditionalUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameAdditional");
}

QStringList Nepomuk::PersonContact::nameHonorificSuffixs() const
{
    return ( property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix") ).toStringList());
}

void Nepomuk::PersonContact::setNameHonorificSuffixs( const QStringList& value )
{
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix"), Variant( value ) );
}

void Nepomuk::PersonContact::addNameHonorificSuffix( const QString& value )
{
    Variant v = property( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix") );
    v.append( value );
    setProperty( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix"), v );
}

QUrl Nepomuk::PersonContact::nameHonorificSuffixUri()
{
    return QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#nameHonorificSuffix");
}

QList<Nepomuk::PersonContact> Nepomuk::PersonContact::allPersonContacts()
{
    return Nepomuk::convertResourceList<PersonContact>( ResourceManager::instance()->allResourcesOfType( QUrl("http://www.semanticdesktop.org/ontologies/2007/03/22/nco#PersonContact") ) );
}


