// This file is generated by kxml_compiler from kde-features.rng.
// All changes you do to this file will be lost.
/*
    This file is part of KDE.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
    USA.

    As a special exception, permission is given to link this program
    with any edition of Qt, and distribute the resulting executable,
    without including the source code for Qt in the source distribution.
 */

#include "kde-features_parser.h"

#include <qfile.h>
#include <qdom.h>
#include <kdebug.h>

Responsible FeaturesParser::parseElementResponsible( const QDomElement &element, bool *ok )
{
  if ( element.tagName() != "responsible" ) {
    kError() << "Expected 'responsible', got '" <<element.tagName() << "'.";
    if ( ok ) *ok = false;
    return Responsible();
  }

  Responsible result = Responsible();

  QDomNode n;
  for( n = element.firstChild(); !n.isNull(); n = n.nextSibling() ) {
    QDomElement e = n.toElement();
  }

  result.setName( element.attribute( "name" ) );
  result.setEmail( element.attribute( "email" ) );

  if ( ok ) *ok = true;
  return result;
}

Feature FeaturesParser::parseElementFeature( const QDomElement &element, bool *ok )
{
  if ( element.tagName() != "feature" ) {
    kError() << "Expected 'feature', got '" <<element.tagName() << "'.";
    if ( ok ) *ok = false;
    return Feature();
  }

  Feature result = Feature();

  QDomNode n;
  for( n = element.firstChild(); !n.isNull(); n = n.nextSibling() ) {
    QDomElement e = n.toElement();
    if ( e.tagName() == "summary" ) {
      result.setSummary( e.text() );
    }
    else if ( e.tagName() == "responsible" ) {
      bool ok;
      Responsible o = parseElementResponsible( e, &ok );
      if ( ok ) result.addResponsible( o );
    }
  }

  result.setStatus( element.attribute( "status" ) );
  result.setTarget( element.attribute( "target" ) );

  if ( ok ) *ok = true;
  return result;
}

Category FeaturesParser::parseElementCategory( const QDomElement &element, bool *ok )
{
  if ( element.tagName() != "category" ) {
    kError() << "Expected 'category', got '" <<element.tagName() << "'.";
    if ( ok ) *ok = false;
    return Category();
  }

  Category result = Category();

  QDomNode n;
  for( n = element.firstChild(); !n.isNull(); n = n.nextSibling() ) {
    QDomElement e = n.toElement();
    if ( e.tagName() == "feature" ) {
      bool ok;
      Feature o = parseElementFeature( e, &ok );
      if ( ok ) result.addFeature( o );
    }
    else if ( e.tagName() == "category" ) {
      bool ok;
      Category o = parseElementCategory( e, &ok );
      if ( ok ) result.addCategory( o );
    }
  }

  result.setName( element.attribute( "name" ) );

  if ( ok ) *ok = true;
  return result;
}

Features FeaturesParser::parseElementFeatures( const QDomElement &element, bool *ok )
{
  if ( element.tagName() != "features" ) {
    kError() << "Expected 'features', got '" <<element.tagName() << "'.";
    if ( ok ) *ok = false;
    return Features();
  }

  Features result = Features();

  QDomNode n;
  for( n = element.firstChild(); !n.isNull(); n = n.nextSibling() ) {
    QDomElement e = n.toElement();
    if ( e.tagName() == "category" ) {
      bool ok;
      Category o = parseElementCategory( e, &ok );
      if ( ok ) result.addCategory( o );
    }
  }


  if ( ok ) *ok = true;
  return result;
}

Features FeaturesParser::parseFile( const QString &filename, bool *ok )
{
  QFile file( filename );
  if ( !file.open( QIODevice::ReadOnly ) ) {
    kError() << "Unable to open file '" << filename << "'";
    if ( ok ) *ok = false;
    return Features();
  }

  QString errorMsg;
  int errorLine, errorCol;
  QDomDocument doc;
  if ( !doc.setContent( &file, false, &errorMsg, &errorLine, &errorCol ) ) {
    kError() << errorMsg << " at " << errorLine << "," << errorCol;
    if ( ok ) *ok = false;
    return Features();
  }

  kDebug() << "CONTENT:" << doc.toString();

  bool documentOk;
  Features c = parseElementFeatures( doc.documentElement(), &documentOk );
  if ( ok ) {
    *ok = documentOk;
  }
  return c;
}


